c--------------------------------------------------------------------------
c  
c  Program to make a time correct inan s-file for one phase and 
c  selected stations, also change weights
c
c  jh jan 2025
c
c--------------------------------------------------------------------------c
c
c
c  changes
c

      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'seisan.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common bliock

      character*80 data(5000)             ! s-file with data in text array

      logical all                         ! true: read all data, false: headers
      integer seiclen                     ! function
      integer code                        ! error return code
      integer nevent                      ! number of events in file
      character*10 keys                   !next choice key for routine findevin
      character*14 starttime,endtime      ! time interval to read
      character*80 basename               ! data base or file name
      character*80 infile                 ! input file or base name
      character*80 eventfile              ! single event file name
      character*80 text
      real*8 msec                         ! abs time
      character*8 phase                   ! phase to correct
      character*5 station(100)            ! stations to correct
      integer nstation                    ! number of stations to correct
      real time_correction                ! time correction for phase
      integer doy                         ! day of year
      integer status,eventno,newmonth,fstart ! for routine findevin
      integer base                        ! type of input 0: seisan data base, 
                                          !     1: index file, 2: single file
      integer weight                      ! phase weight
      integer nargs                       ! number of arguments
      character*80 args(10)               ! arguments
c---time of making update
      character*12 p_time
      character*14 proc_time
      character*4 operator 
      integer i,k                         ! counter

      nstation=0

      call get_seisan_def

c
c   check if input via argumants
c
      call get_arguments(nargs,args)
c
c   open output file
c
      open(2,file='tcorw.out',status='unknown')
c
c   input from keyboard
c
      write(6,*)'Phase to correct '
      read(5,'(a)') phase
      write(6,*)
     *'Stations to correct, if enter all stations will be corrected '//
     *'for phase ',phase

 1    continue
      read(5,'(a)') text
      if(text.ne.' ') then
         nstation=nstation+1
         station(nstation)=text(1:5)
         goto 1
      endif

      write(6,*)'Time correction to be added (sec), enter for none'
      read(5,'(a)') text
      if(text.eq.' ') then
         time_correction=0.0
      else
         read(text,*) time_correction
      endif  

 2    continue
      write(6,*)'Replace weight, 0-4, enter if no change of weight,' 
     *//' weight 9 not changed'
      read(5,'(a)') text
      if(text.eq.' ') then
         weight=-1
      else
         read(text,*) weight
         if(.not.(weight.ge.0.and.weight.le.4)) then
             write(6,*)'Wrong weight'
             goto 2
         endif
      endif  
c
c   if argument with fiel name, skip input
c
      if(nargs.gt.0) then
        infile=args(1)
        base=2
      else
c
c   get input file name, or data base with time interval
c

      write(*,*) ' Event data input - select one:'
      write(*,*)
      WRITE(*,*) 
     *'    SEISAN default data base or                     :',
     *'Enter '
      write(*,*) 
     *'    Alternative data base, give 1-5 letter code or  :'  
      WRITE(*,*) 
     *'    Local index file, name must start with index or :'
      WRITE(*,*) 
     *'    Local data base, write ,, or                    :'
      WRITE(*,*) 
     *'    Filename for one file, min. 6 chars or with a . : '
      
      write(*,*)
      read(*,'(a)') infile
      basename=infile(1:80)
                       
      write(*,*)
C
c   check if this is a single multiple event file (base=2),
c   general data base (base=0) or  a local data base or 
c   index file (base=1)
c

      starttime=' '
      endtime=' '

      keys(1:4)='NEXT'    ! always use next event

c
c   initially assume a file
c
      base=2
c
c   a SEISAN 5 letter data base, blank is default data base, ',,'
c   is a local data base. the name cannot have a '.' and must
c   be less than 6 chars long
c
      if(seiclen(basename).lt.6.and.index(basename,'.').eq.0) then 
         base=0
      endif
c
c   case of index file or local data base
c
 
      if(basename(1:5).eq.'INDEX'.or.basename(1:5).eq.'index'.
     *     or.basename(1:2).eq.',,') then
        base=1
      endif
                              
c
c  get time interval for a seisan data base, no time interval used for
c  index file or local data base
c
      if(base.eq.0) then
         write(*,'('' Start Time           (YYYYMMDDHHMMSS): '',$)')
         read(*,'(a14)') starttime
         write(*,'('' End Time, enter is to end of month:    '',$)')
         read(*,'(a14)') endtime
         write(*,*)
      endif

      endif
c
c   open access for the the relevant input option
c
  

c
c  a file
c
      if(base.eq.2) then
         open(1,file=infile,status='old',err=5)
         goto 6
 5       continue
         write(6,*)' Input file not found'
         stop
 6       continue
      endif


      all=.true.                  ! read all parameters
      nevent=0                    ! initialize counter

c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c

  50  continue

c
c   read from relevant input type
c
      if(base.lt.2) then     ! data base  or index file event
         call findevin
     *   (basename,starttime,endtime,keys,0,eventno,
     *   eventfile,fstart,newmonth,status)
c
c   check if end of time interval or errors, then
c   stop
C     
         if(status.gt.0) then
            write(6,*)' STOP WITH STATUS=',status
            goto 1000  ! stop
         endif
C
C   open data base input single event file
c

         open(1,file=eventfile,status='old',err=7)
         goto 8
 7       continue
         write(6,*)' Input file not found: ',eventfile
         stop
 8       continue
      endif

c
c   read all parameters for one event from file unit 1
c
      call rea_event_in(1,all,data,code)

c
c   close file if from data base since only one event
c
      if(base.lt.2) close(1)
c
c   check if end of file (code=1), if so jump out of loop
c
      if(code.eq.1) goto 1000
c
      nevent=nevent+1               ! count events
c
c   write the whole first header line
c
      write(6,'(a)') data(1)(1:79)
c     

c
c correct arrival time
c
c
c----------------------------------------------------
c

c
c   correct all stations with correct phase
c
      if(nstation.eq.0) then
         do i=1,rea_nphase
           if(rea_phase(i).eq.phase) then
               call timsec(rea_year(i),rea_month(i),rea_day(i),
     *         rea_hour(i),rea_min(i),rea_sec(i),msec)
               msec=msec+time_correction
               call sectim(msec,rea_year(i),doy,rea_month(i),rea_day(i),
     *         rea_hour(i),rea_min(i),rea_sec(i))
               if(weight.gt.-1.and.rea_weight_in(i).ne.'9')
     *         write(rea_weight_in(i),'(i1)') weight
            endif
         enddo
      endif

c
c   correct all stations with correct phase and station
c
      if(nstation.ge.1) then
         do k=1,nstation
            do i=1,rea_nphase
              if(rea_phase(i).eq.phase.and.rea_stat(i).eq.station(k)) 
     *            then
                  call timsec(rea_year(i),rea_month(i),rea_day(i),
     *            rea_hour(i),rea_min(i),rea_sec(i),msec)
                  msec=msec+time_correction
                  call sectim(msec,rea_year(i),doy,rea_month(i),
     *            rea_day(i),rea_hour(i),rea_min(i),rea_sec(i))
                  if(weight.gt.-1.and.rea_weight_in(i).ne.'9')
     *            write(rea_weight_in(i),'(i1)') weight
               endif
            enddo
         enddo
      endif
c
c   write out modified event, the array data has also been modified
c
       call rea_event_out(2,all,data,code)


c   possibely overwrite for one event
c
       if(args(2).eq.'overwrite') then
           if(nargs.eq.3) then
               operator=args(3)(1:4)
           else
               operator=' '
           endif
           rewind 1
           call get_operator(operator)
c
c   get system time
c
           call systime(p_time,proc_time)
c
c   update id line
c
            if(rea_id_line.ne.' ') then
               WRITE(rea_id_line(31:34),'(A)')OPERATOR
               WRITE(rea_id_line(13:26),'(A)')PROC_TIME
               WRITE(rea_id_line(9:11),'(A)')'TCW'
            else
               write(6,*)' No ID line !!!!!!!'
            endif

           call rea_event_out(1,all,data,code)
           close(1)
           goto 1000
       endif


c
c   get next event
c
      goto 50
c
c     end of file or data base
c
 1000 continue
c
      write(6,*)            ! blank line
      close(2)              ! close output file
      write(6,*) 'Number of events in input file or data base', nevent
      write(6,*) 'Output file is tcorw.out'

      stop
      end
